Summary: The LAPACK libraries for numerical linear algebra.
Name: lapack
Version: 3.0
Release: 12a
License: Freely distributable
Group: Development/Libraries
# If you want the source, look for the files with the .gz prefix
Source0: http://www.netlib.org/lapack/lapack.tar.bz2
Source1: http://www.netlib.org/lapack/manpages.tar.bz2
Source2: Makefile.blas
Source3: Makefile.lapack
Source4: http://www.netlib.org/lapack/lapackqref.ps
Source5: http://www.netlib.org/blas/blasqr.ps
Patch0: lapack-20010525.patch
URL: http://www.netlib.org/lapack/
BuildRoot: %{_tmppath}/lapack-%{version}-root

%description
LAPACK (Linear Algebra PACKage) is a standard library for numerical
linear algebra. LAPACK provides routines for solving systems of
simultaneous linear equations, least-squares solutions of linear
systems of equations, eigenvalue problems, and singular value
problems. Associated matrix factorizations (LU, Cholesky, QR, SVD,
Schur, and generalized Schur) and related computations (i.e.,
reordering of Schur factorizations and estimating condition numbers)
are also included. LAPACK can handle dense and banded matrices, but
not general sparse matrices. Similar functionality is provided for
real and complex matrices in both single and double precision. LAPACK
is coded in Fortran77 and built with gcc.

%package -n blas
Summary: The BLAS (Basic Linear Algebra Subprograms) library.
Group: Development/Libraries
Obsoletes: lapack-blas

%description -n blas
BLAS (Basic Linear Algebra Subprograms) is a standard library which
provides a number of basic algorithms for numerical algebra. Man
pages for blas are available in the blas-man package.

%package -n blas-man
Summary: Man pages for BLAS (Basic Linear Algebra Subprograms) routines.
Group: Documentation
Obsoletes: lapack-blas-man

%description -n blas-man
The blas-man package contains documentation for BLAS (Basic Linear
Algebra Subprograms) routines in the form of man pages.

%package man
Summary: Documentation for the LAPACK numerical linear algebra libraries.
Group: Documentation

%description man
Documentation, in the form of man pages, for the LAPACK numerical
linear algebra libraries.

%prep
%setup -q -n LAPACK
%setup -q -D -T -a 1 -n LAPACK
%patch0 -p1
cp -f $RPM_SOURCE_DIR/Makefile.blas BLAS/SRC/Makefile
cp -f $RPM_SOURCE_DIR/Makefile.lapack SRC/Makefile

%build
cd BLAS/SRC
FFLAGS="$RPM_OPT_FLAGS" make static
cp -p libblas.a ../..

%ifnos darwin
make clean
FFLAGS="$RPM_OPT_FLAGS -fPIC" make shared
cp libblas.so.3.0.3 ../..
cd ../..
ln -s libblas.so.3.0.3 libblas.so
%else
cd ../..
%endif

cd SRC
FFLAGS="$RPM_OPT_FLAGS" make static

cp -p liblapack.a ..

%ifnos darwin
make clean
FFLAGS="$RPM_OPT_FLAGS -fPIC" make shared
cp liblapack.so.3.0.3 ..
%endif

cd ..
cp %{SOURCE4} lapackqref.ps
cp %{SOURCE5} blasqr.ps


%install
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
mkdir -p $RPM_BUILD_ROOT%{_mandir}/manl

%ifnos darwin
cp -f liblapack.so.3.0.3 $RPM_BUILD_ROOT%{_prefix}/lib/liblapack.so.3.0.3
cp -f libblas.so.3.0.3 $RPM_BUILD_ROOT%{_prefix}/lib/libblas.so.3.0.3
%endif
cp -fp libblas.a $RPM_BUILD_ROOT%{_prefix}/lib/libblas.a
cp -fp liblapack.a $RPM_BUILD_ROOT%{_prefix}/lib/liblapack.a

cd blas/man/manl
gzip -9 *
cd ../../..
%ifnos darwin
echo "%defattr(-, root, root)" > lapackmans
%else
echo "%defattr(-, root, wheel)" > lapackmans
%endif
%ifnos darwin
find blas/man/manl -type f -printf "%{_mandir}/manl/%f\n" > blasmans
%else
find blas/man/manl -type f | sed -e 's;.*/\([^/]*\);\1;' | sed -e "s;^;%{_mandir}/manl/;" > blasmans
%endif
cd man/manl
gzip -9 *
cd ../..
%ifnos darwin
echo "%defattr(-, root, root)" > lapackmans
%else
echo "%defattr(-, root, wheel)" > lapackmans
%endif
# These are also in the BLAS package
rm -f man/manl/lsame.l*
rm -f man/manl/xerbla.l*
%ifnos darwin
find man/manl -type f -printf "%{_mandir}/manl/%f\n" > lapackmans
%else
find man/manl -type f | sed -e 's;.*/\([^/]*\);\1;' | sed -e "s;^;%{_mandir}/manl/;" > lapackmans
%endif

cp -f blas/man/manl/* $RPM_BUILD_ROOT%{_mandir}/manl
cp -f man/manl/* $RPM_BUILD_ROOT%{_mandir}/manl
cd $RPM_BUILD_ROOT%{_prefix}/lib

%ifnos darwin
ln -sf liblapack.so.3.0.3 liblapack.so
ln -sf liblapack.so.3.0.3 liblapack.so.3
ln -sf liblapack.so.3.0.3 liblapack.so.3.0
ln -sf libblas.so.3.0.3 libblas.so
ln -sf libblas.so.3.0.3 libblas.so.3
ln -sf libblas.so.3.0.3 libblas.so.3.0
%endif

%ifnos darwin
%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n blas -p /sbin/ldconfig

%postun -n blas -p /sbin/ldconfig
%endif

%clean
rm -fr $RPM_BUILD_ROOT

%files
%ifnos darwin
%defattr(-,root,root)
%else
%defattr(-,root,wheel)
%endif
%doc README lapackqref.ps
%{_prefix}/lib/liblapack.*

%files -n blas
%ifnos darwin
%defattr(-,root,root)
%else
%defattr(-,root,wheel)
%endif
%doc blasqr.ps
%{_prefix}/lib/libblas.*

%files -n blas-man -f blasmans
%ifnos darwin
%defattr(-,root,root)
%else
%defattr(-,root,wheel)
%endif

%files man -f lapackmans
%ifnos darwin
%defattr(-,root,root)
%else
%defattr(-,root,wheel)
%endif

%changelog
* Tue Oct 23 2001 Keisuke Fujii <fujiik@jlcuxf.kek.jp> 3.0-12a
- 1st build on MacOS X Release 10.1

* Mon Aug 13 2001 Trond Eivind Glomsrd <teg@redhat.com> 3.0-12
- The man-pages for xerbla and lsame were in blas-man and lapack-man (#51605)

* Fri Jun  8 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Reenable optimization for IA64

* Fri May 25 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Add all patches from the LAPACK site as of 2001-05-25
- Use this workaround for IA64 instead
- Remove SPARC workaround
- Don't exclude IA64

* Thu Dec 07 2000 Trond Eivind Glomsrd <teg@redhat.com>
- rebuild for main distribution

* Mon Nov 20 2000 Trond Eivind Glomsrd <teg@redhat.com>
- add the LAPACK Quick Reference Guide to the docs
- add the BLAS Quick Reference Guide to the docs

* Tue Aug 01 2000 Trond Eivind Glomsrd <teg@redhat.com>
- fix lack of ldconfig in postuninstall script

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Mon Jul 10 2000 Trond Eivind Glomsrd <teg@redhat.com>
- updated with the latest updates (new tarfile..) from netlib 

* Thu Jun 15 2000 Trond Eivind Glomsrd <teg@redhat.com>
- use %%{_mandir}
- added some flags to work around SPARC compiler bug

* Wed Jan 19 2000 Tim Powers <timp@redhat.com>
- bzipped sources to conserve space

* Tue Jan  4 2000 Jeff Johnson <jbj@redhat.com>
- build for PowerTools 6.2.

* Sat Dec 25 1999 Joachim Frieben <jfrieben@hotmail.com>
- updated to version v3.0 + update as of Tue Nov 30 1999

* Sat Oct 23 1999 Joachim Frieben <jfrieben@hotmail.com>
- updated Red Hat makefiles to v3.0

* Mon Aug 2 1999 Tim Powers <timp@redhat.com>
- updated to v3.0
- built for 6.1

* Mon Apr 12 1999 Michael Maher <mike@redhat.com>
- built package for 6.0

* Sat Oct 24 1998 Jeff Johnson <jbj@redhat.com>
- new description/summary text.

* Fri Jul 17 1998 Jeff Johnson <jbj@redhat.com>
- repackage for powertools.

* Sun Feb 15 1998 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
 [lapack-2.0-9]
 - No code updates, just built with a customized rpm -
   this should make dependencies right.

* Sat Feb 07 1998 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
 [lapack-2.0-8]
 - Total rewrite of the spec file
 - Added my own makefiles - libs should build better,
   static libs should work (and be faster than they
	would be if they had worked earlier ;)
 - No patch necessary anymore.
 - Renamed lapack-blas and lapack-blas-man to
   blas and blas-man. "Obsoletes:" tag added.
   (oh - and as always: Dedicated to the girl I
   love, Eline Skirnisdottir)

* Sat Dec 06 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
 [lapack-2.0-7]
  - added a dependency to glibc, so people don't try with libc5

* Thu Nov 20 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
  [lapack-2.0-6]
  - removed etime.c
  - compiled with egcs, and for glibc 2.0

* Sun Oct 12 1997 Trond Eivind Glomsrd <teg@pvv.ntnu.no>
  [lapack-2.0-5]
  - added a changelog
  - cleaned up building of shared libs
  - now uses a BuildRoot
  - cleaned up the specfile
